package backend.operators;

public class AsmAdd extends BinOp {

  public AsmAdd(int reg, int op_reg) {
    super(reg,op_reg);
    length = 2;
  }

  public String toString() {
      return "ADD " + src_dest.toString() + " += " + operand.toString();
  }

  public byte[] getCode (byte[] list, int off) {

    list[off  ] = (byte)(0x01);  //add
    list[off+1] = (byte)(0xc0 + src_dest.get() + 8*operand.get());  //r32 to r/m32 == operand to src_dest

    return list;
  }

}
