package backend.operators;

public class Register {

  // Konstanten fr Register NIEMALS ndern!
  public static final int EAX = 0;
  public static final int EBX = 3;
  public static final int ECX = 1;
  public static final int EDX = 2;
  public static final int ESI = 6;
  public static final int EDI = 7;
  public static final int ESP = 4;
  public static final int EBP = 5;
  /*
   *  public static final int EIP = 8;
   *
   *  EIP sollte auskommentiert werden, da man (normalerweise) sowieso keinen
   *  Zugriff auf den EIP hat.
   *  Auer: kompiliertes Programm ist Betriebssystem bzw. Treiber oder das
   *         Programm luft unter DOS...
   */

  private int reg;

  public Register(int thisReg) {
    reg = thisReg;
  }

  public String toString() {
    String retval = null;
    switch (reg) {
        case (EAX): retval = "EAX"; break;
        case (EBX): retval = "EBX"; break;
        case (ECX): retval = "ECX"; break;
        case (EDX): retval = "EDX"; break;
        case (ESI): retval = "ESI"; break;
        case (EDI): retval = "EDI"; break;
        case (ESP): retval = "ESP"; break;
        case (EBP): retval = "EBP"; break;
      //case (EIP): retval = "EIP"; break;
    }
    return retval;
  }

  public int get() {
    return reg;
  }
}

