package frontend.symbol.visualize;

import frontend.symbol.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;

public class JTreeSymtabFrame extends JFrame {

    static final int POS_X = 200;
    static final int POS_Y = 0;
    static final int WIDTH = 200;
    static final int HEIGHT = 300;

    private JTreeSymtabPanel jtsp;

    public JTreeSymtabFrame(String title, JTreeSymtabPanel jtsp) {
        super(title);
        this.jtsp = jtsp;
        setContentPane(jtsp);
        setBounds(POS_X, POS_Y, WIDTH, HEIGHT);
        setVisible(true);
    }

    public JTreeSymtabFrame(String title) {
        this(title, new JTreeSymtabPanel(new JTreeSymtabModel()));
    }


    public JTreeSymtabPanel getPanel() {
        return jtsp;
    }


}
