package intermediate.operators;

import intermediate.*;

public class MOVE extends Statement {

    private Expression dest, src;

    public MOVE(Expression dest, Expression src) {
        this.dest = dest;
        this.src = src;
        addChild(dest);
        addChild(src);
    }

    public String toString() {
        return "MOVE";
    }


    public String toStringList() {
        return "MOVE(" + dest.toStringList() + ", " + src.toStringList() + ")";
    }
    
    public Expression getDest(){
    	return dest;
    }
    public void setDest(Expression dest){
    	this.dest = dest;
    }
    
    public Expression getSrc(){
    	return src;
    }
    public void setSrc(Expression src){
    	this.src = src;
    }
}