package intermediate.operators;

import intermediate.*;

public class SEQ extends Statement {

    private Statement left, right;

    public SEQ(Statement left, Statement right) {
        this.left = left;
        this.right = right;
        addChild(left);
        addChild(right);
    }

    public String toString() {
        return "SEQ";
    }

    public String toStringList() {
        return left.toStringList() + "\n" + right.toStringList();
    }


}