package frontend.parsetree;

import intermediate.*;
import intermediate.operators.*;
import antlr.Token;

public class AssignNode extends PL0Node {

    public AssignNode(Token tok) {
        super(tok);
    }

    public Statement convertStatement() {
        PL0Node dest = (PL0Node)getFirstChild();
        PL0Node src = (PL0Node)dest.getNextSibling();
        return new MOVE(dest.convertExpression(), src.convertExpression());
    };

}
