package frontend.parsetree;

import antlr.Token;
import intermediate.*;
import intermediate.operators.*;

public class NumberNode extends PL0Node {

    public NumberNode(Token tok) {
        super(tok);
    }

    public Statement convertStatement() {
        return null;
    };

    public Expression convertExpression() {
        int value = Integer.parseInt(getText());
        return new CONST(value);
    }

}
