package backend.operators;

import backend.AsmStatement;
import backend.BinarFile;

public class AsmFL extends AsmStatement {

  private int block;

  public AsmFL(int block) {
    this.block = block;
    length = 7;
  }

  public String toString() {
      return "FrameLeave " + String.valueOf(block);
  }

  public byte[] getCode (byte[] list, int off) {
    int var=10; /* Anz. lokaler Variablen+Konstanten */
    int value = 4 * var;

    /* add value to esp */
    list[off  ] = (byte)(0x81);  // add
    list[off+1] = (byte)(0xc4);  // esp
    list = BinarFile.WriteLongToByteList(value, list, off+2);  // imm32

    // alter BasePointer wird vom Call wiederhergestellt

    /* ret */
    list[off+6] = (byte)(0xc3);  // ret

    return list;
  }

}
