package frontend.symbol;

public class NumberOutOfRangeException extends RuntimeException {

    public NumberOutOfRangeException(String sNumber, int line, int column) {
        super("Error at line " + line + ":" + column +
                ": Numbers may range from -2147483648 to 2147483647, but " +
                sNumber + " has been found.");

    }
}