package frontend.symbol;

import java.io.File;

/**
 * Reprsentiert eine Position im Quelltext, enthlt Zeile und Spalte.
 */
class Occurrence {

    private int line, column;

    /**
     * Konstruktor
     */
    Occurrence(int line, int column) {
        this.line = line;
        this.column = column;
    }

    /**
     * Gibt die Zeile zurck.
     */
    public int getLine() {
        return line;
    }

    /**
     * Gibt die Spalte zurck
     */
    public int getColumn() {
        return column;
    }

    /**
     * Gibt eine Reprsentation der Position zurck
     */
    public String getLocation() {
        return line + ":" + column;
    }


    public String toString() {
        return "Occurrence [" + getLocation() + "]";
    }
}
