package frontend.parsetree;

import antlr.Token;
import intermediate.*;
import intermediate.operators.*;
import frontend.symbol.*;
//import frame.*;

public class CallNode extends PL0Node {

    public CallNode(Token tok) {
        super(tok);
    }

    public Statement convertStatement() {
        PL0Node parameter = (PL0Node)getFirstChild();
        ScopeDef sd = (ScopeDef)SymbolTable.getSymbolTable().lookup(parameter.getText());
        int number = sd.getScopeNumber();
        return new EXP(new CALL(new CONST(number)));
    };



    /*public Expression convertExpression() {
        int[] pos = SymbolTable.getSymbolTable().lookupPos(getText());
        Expression ident = new TEMP(frame.fp());
        for (int i = 0; i < pos[0]; i++) {
            ident = new MEM(new BINOP(BINOP.PLUS, ident, new CONST(frame.STATIC_LINK)));
        }
        ident = new MEM(new BINOP(BINOP.PLUS, ident, new CONST(pos[1] + frame.getMinOffset())));
        return ident;
    }*/
}
