package frontend.parsetree;

import antlr.Token;
import intermediate.*;
import intermediate.operators.*;

public class MinusNode extends PL0Node {

    public MinusNode(Token tok) {
        super(tok);
    }

    public Statement convertStatement() {
        return null;
    };

    public Expression convertExpression() {
        PL0Node expr = (PL0Node)getFirstChild();
        return new BINOP(BINOP.MUL, new CONST(-1), expr.convertExpression());
    }

}
