package frontend.symbol;

/**
 * Instanzen dieser Klasse stehen fr eine Konstantendeklaration.
 */
public class ConstantDef extends Definition  {

    private int value;

    /**
     * Konstruktor
     */
    ConstantDef(String name, int value, Occurrence occ, ScopeDef parentScope) {
        super(name, occ, parentScope);
        this.value = value;
    }

    /**
     * Liefert den Typ der Definition zurck, Symbol.SYMBOL_CONST;
     */
    public int getType() {
        return Symbol.SYMBOL_CONST;
    }

    public String toString() {
        return "constant " + getName();
    }

    public int getValue() {
        return value;
    }


}
