package intermediate;

import java.util.*;
import backend.InterpreterFrame;

public class FrameContainer extends HashMap {

    public FrameContainer() {
    }


    public InterpreterFrame getFrame(int index) {
        return (InterpreterFrame)get(new Integer(index));
    }


    public void addFrame(InterpreterFrame frm, int index) {
        put(new Integer(index), frm);
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        for (Iterator it = keySet().iterator(); it.hasNext();) {
            Integer key = (Integer)it.next();
            sb.append("====================================\n");
            sb.append("Frame " + key.toString() + ":\n");
            InterpreterFrame iframe = ((InterpreterFrame)get(key));
            sb.append(iframe.toString());
            sb.append("\n\n");
        }
        return sb.toString();
    }
}
