package intermediate.operators;

import intermediate.*;

public class INPUT extends Statement {

    private MEM address;

    public INPUT(MEM address) {
        this.address = address;
        addChild(address);
    }

    public String toString() {
        return "INPUT";
    }

    public String toStringList() {
        return "INPUT(" + address.toStringList() + ")";
    }

    public MEM getAddress() {
        return address;
    }

}